/*
 * Creates the menu scene.
 */
#ifndef MENU_H
#define MENU_H

#include "slenderer.h"

#include "ld30.h"
#include "world_loader.h"

#define LD_MENU_BACKGROUND_LAYER 0
#define LD_MENU_AMBIANCE_LAYER 1
#define LD_MENU_BUTTON_LAYER 2
#define LD_MENU_INFO_LAYER 3

#define LD_LEVELS_IMPLEMENTED 4

void ld_open_menu( GLFWwindow *win_handle, int key, int scancode, int modifiers );
void ld_toggle_menu( GLFWwindow *win_handle, int key, int scancode, int modifiers );
void ld_reload( GLFWwindow *win_handle, int key, int scancode, int modifiers );
void ld_play( unsigned int scene_id, unsigned int quad_id, int button );
void ld_play_custom( unsigned int scene_id, unsigned int quad_id, int button );
void ld_quit_mouse( unsigned int scene_id, unsigned int quad_id, int button );
void ld_resume( unsigned int scene_id, unsigned int quad_id, int button );

void ld_toggle_credits( unsigned int scene_id, unsigned int quad_id, int button );
void ld_toggle_help( unsigned int scene_id, unsigned int quad_id, int button );

/*
 * Crreate the menu.
 */
void ld_menu_create( sl_window *win );

/*
 * We need to clean up the post process timer.
 */
void ld_menu_destroy( );

vul_timer_t *ld_menu_post_timer;
ui64_t ld_menu_post_last_time;
GLfloat ld_menu_post_time_modulo_second;
SL_BOOL ld_menu_post_phase_rising;

ui32_t ld_menu_scene_id;
ui32_t ld_menu_play_button;
ui32_t ld_last_world_scene_id;

ui32_t ld_game_current_level;
char *ld_game_custom_level_path;

ui32_t ld_menu_help_id;
ui32_t ld_menu_credits_id;


#endif