/*
 * Welcome to LD30 - Connected Worlds. 27h left and first plan was
 * sent to hell with my drawing skills. Attempt nr. 2...
 * @TODO: I see you are revisiting this project, future me. 
 * First off, there's a massive memory-leak when reloading, 'cause
 * we don't actually destroy the old scene when we reload. Oops.
 * Second, Fix the bug where, if we DO clean up, the menu gets fucked after
 * a few reloads. The problem occurs when we hit 8 scenes and realloc the 
 * vector; something doesn't get properly moved, and the get_*_for_scene
 * return garbled things, as well as the scene being garbled itself.
 * We need to fix this somehow!
 */
#include "ld30.h"
#include "menu.h"

int main( int argc, char **argv )
{
	sl_box uvs;
	sl_window *win;
	sl_program *prog;
	sl_renderable *rend;

	// Store arguments
	if( argc > 1 ) {
		ld_game_custom_level_path = argv[ 1 ]; // First argument is assumed to be a level path
	} else {
		ld_game_custom_level_path = NULL;
	}

	// Initialize slenderer
	sl_renderer_create( );
	win = sl_renderer_open_window( RESOLUTION_WIDTH, RESOLUTION_HEGIHT, "LD30v2", SL_FALSE, SL_FALSE );
	ld_window_instance_id = win->window_id;
	
	// Initialize the controller
	sl_controller_create( );
	sl_controller_register_window( win );
	sl_controller_add_key_press_callback( GLFW_KEY_ESCAPE, ld_open_menu );
		
	// Create the default program 
	prog = sl_renderer_allocate_program( );
	prog->vert_prog_src = sl_program_default_vp_src;
	prog->frag_prog_src = sl_program_default_fp_src;
	sl_program_create( prog );
	ld_program_instance_id = prog->program_id;

	// Create the default renderable
	rend = sl_renderer_allocate_renderable( );
	sl_bset_scalar( &uvs, 0.0f, 0.0f, 1.0f, 1.0f );
	sl_renderable_create( rend, &uvs );
	ld_renderable_instance_id = rend->renderable_id;

	// Load the tile dictionary
	ld_tile_read_dictionary( );
	
	// Initialize the bugger global to NULL
	ld_bugger_handler_instance = NULL;

	// Create the menu scene
	ld_menu_create( win );
	ld_open_menu( win->handle, 0, 0, 0 );
	
	// Enter the loop
	while( !glfwWindowShouldClose( win->handle ) )
	{
		// Update the buggers 
		ld_bugger_update( );

		// Render the scene
		sl_renderer_render_scene( ld_active_scene_id, ld_window_instance_id, SL_TRUE );

		// Make sure our window handle is still accurate
		win = sl_renderer_get_window_by_id( ld_window_instance_id );
	}
	
	// Clean up
	ld_world_finalize( );
	ld_buggers_finalize( );

	sl_renderer_destroy( );
}